--
-- Patch DML de GRHUM du 10/10/2013 à exécuter depuis le user GRHUM
--
-- Rem : fichier encodé UTF-8

SET DEFINE OFF;

--
--
-- Fichier : 1
-- Type : DML
-- Schema : GRHUM
-- Numero de version : 1.8.4.0
-- Date de publication : 10/10/2013
-- Auteur(s) : Julien Lafourcade

-- Licence : CeCILL version 2
--
--

WHENEVER SQLERROR EXIT SQL.SQLCODE;



------------------V20131010.142442__DML_Ajout_association_pour_gestion_theses.sql-------------------

declare
  ass_id_doc integer;
  tas_id_pere integer;
  nb integer;
  nb_ass_doct integer;
  nb_assres_doct integer;

begin 
  select tas_id into tas_id_pere from grhum.type_association where  tas_code = 'ROLE';
  
  select count(*) into nb_ass_doct from grhum.association where ass_code = 'DOCT';
  if (nb_ass_doct = 1) 
  then 
    select ass_id into ass_id_doc from grhum.association where ass_code = 'DOCT';
    select count(*) into nb_assres_doct
    from GRHUM.ASSOCIATION_RESEAU ar,GRHUM.ASSOCIATION A1 
    where ar.ass_id_fils = ass_id_doc
    and ar.ass_id_pere = A1.ass_id
    and a1.ass_code = 'FONCTION';
    
    if (nb_assres_doct = 0)
    then 
      INSERT INTO GRHUM.ASSOCIATION_RESEAU
      SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
      FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
      WHERE A1.ASS_LIBELLE='FONCTION'
      AND A2.ASS_CODE='DOCT';
    end if;
  end if;
  
  
  
  -- Pour la cotutelle
  -- un sous-réseau d'associations appelé COTUTELLE pour les cotutelles.
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'ETABLISSEMENT DE COTUTELLE',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_COT_ETAB');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_COT_ETAB';   
  
  
  -- Pour les directeurs de thèse
  -- un sous-réseau direction de thèse DIRECTION :
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'DIRECTION THESE',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_DIR');
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Directeur de thèse',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_DIR_THESE');
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Co-encadrant de thèse',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_DIR_COENC');
  
  
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_DIR';
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_DIR'
  AND A2.ASS_CODE='D_DIR_THESE';
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_DIR'
  AND A2.ASS_CODE='D_DIR_COENC';
    
  -- Pour le rattachements du doctorant au labo pour la thèse
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Laboratoire de thèse',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_LAB_THESE');
  
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_LAB_THESE';
  
  -- Pour le partenaire ECOLE DOCTORALE de rattachement 
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Ecole Doctorale de rattachement',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_ED_R');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_ED_R';
  
  
  
  -- Un sous réseau pour les différents roles liés au jury
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'JURY - SOUTENANCE',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_JURY');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_JURY';
  
  -- Un sous réseau pour les types de membres de jury
  -- Pour typer les membres du jury de thèse en président, rapporteur etc.
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'TYPE MEMBRES JURY',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_TYPE_JURY');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_JURY'
  AND A2.ASS_CODE='D_TYPE_JURY';
  
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Président',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_JR_PRES');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_TYPE_JURY'
  AND A2.ASS_CODE='D_JR_PRES';
  

  --
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Membre',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_JR_MEM');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_TYPE_JURY'
  AND A2.ASS_CODE='D_JR_MEM';
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Invité',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_JR_INV');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_TYPE_JURY'
  AND A2.ASS_CODE='D_JR_INV';
  
  -- une association pour définir les rapporteurs qui ne sont pas forcément membres du jury.
  
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Rapporteur',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_JURY_RAP');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='D_JURY'
  AND A2.ASS_CODE='D_JURY_RAP';
  
  -- un role d'employeur pour les financements de these
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Employeur',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_EMPLOYEUR');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_EMPLOYEUR';
  
  -- un role de financeur pour les financements de these
  INSERT INTO GRHUM.ASSOCIATION (ASS_ID,ASS_LIBELLE,D_CREATION,D_MODIFICATION,TAS_ID,ASS_RACINE,ASS_CODE) 
  VALUES (ASSOCIATION_SEQ.NEXTVAL,'Financeur',SYSDATE,SYSDATE,tas_id_pere,NULL,'D_FINANCEUR');
  
  INSERT INTO GRHUM.ASSOCIATION_RESEAU
  SELECT ASSOCIATION_RESEAU_SEQ.NEXTVAL,A1.ASS_ID,A2.ASS_ID,NULL,NULL,SYSDATE,SYSDATE
  FROM GRHUM.ASSOCIATION A1, GRHUM.ASSOCIATION A2
  WHERE A1.ASS_CODE='DOCT'
  AND A2.ASS_CODE='D_FINANCEUR';



end;
/



--DB_VERSION 
INSERT INTO GRHUM.DB_VERSION(DBV_ID,DBV_LIBELLE,DBV_DATE,DBV_INSTALL,DBV_COMMENT) VALUES(GRHUM.DB_VERSION_SEQ.NEXTVAL,'1.8.4.0',to_date('10/10/2013','DD/MM/YYYY'),sysdate,'TODO');
COMMIT;
